# Copyright © 2023 Neven Sajko

module FindMinimaxPolynomial

include("NumericalErrorTypes.jl")
include("NumericalErrors.jl")
include("LinearInterpolation.jl")
include("CollectionWithReserved.jl")
include("SortedBoundedLengthVectors.jl")
include("GoldenSectionSearch.jl")
include("BisectionMethod.jl")
include("FindRoots.jl")
include("PolynomialApproximationErrorLocalMaxima.jl")
include("TinyFilter.jl")
include("ApproximateInfinityNorm.jl")
include("IntervalHelpers.jl")
include("SkipVectors.jl")
include("LinCombs.jl")
include("SymbolicGaussianEliminationVandermonde.jl")
include("OverdeterminedSystemConsistencyConstraints.jl")
include("VandermondeInverse.jl")
include("PolynomialPassingThroughIntervals.jl")
include("ToSparsePolynomial.jl")
include("CompressedPolynomials.jl")
include("Minimax.jl")

end
