# Copyright © 2023 Neven Sajko

module NumericalErrorTypes

export NumericalErrorType, AbsoluteError, RelativeError

abstract type NumericalErrorType end
abstract type NumericalErrorTypeUnsigned <: NumericalErrorType end
abstract type NumericalErrorTypeSigned <: NumericalErrorType end
struct AbsoluteErrorSigned <: NumericalErrorTypeSigned end
struct RelativeErrorSigned <: NumericalErrorTypeSigned end
struct AbsoluteError <: NumericalErrorTypeUnsigned end
struct RelativeError <: NumericalErrorTypeUnsigned end
struct RelativeDistance <: NumericalErrorType end

Base.unsigned(::AbsoluteErrorSigned) = AbsoluteError()
Base.unsigned(::RelativeErrorSigned) = RelativeError()

Base.unsigned(e::NumericalErrorTypeUnsigned) = e

Base.signed(::AbsoluteError) = AbsoluteErrorSigned()
Base.signed(::RelativeError) = RelativeErrorSigned()

Base.signed(e::NumericalErrorTypeSigned) = e

end
