# Copyright © 2022 Neven Sajko

module SkipVectors

export SkipVec

struct SkipVec{E <: Any, V <: AbstractVector{E}} <: AbstractVector{E}
  v::V
  skip_index::Int

  function SkipVec(v::V, i::Int) where {E <: Any, V <: AbstractVector{E}}
    (length(v) < 1) && error("vec too small")
    in(i, axes(v, 1)) || error("index out of bounds")
    new{E, V}(v, i)
  end
end

Base.size(s::SkipVec) = (length(s.v) - 1,)

Base.IndexStyle(::Type{<:SkipVec}) = IndexLinear()

Base.getindex(s::SkipVec, i::Int) =
  <(i, s.skip_index) ? s.v[i] : s.v[i + 1]

end
