# Copyright © 2023 Neven Sajko

module ToSparsePolynomial

import Polynomials

to_sparse_polynomial(
  coefficients::AbstractVector{F},
  monomials::AbstractVector{S},
  ::Val{var} = Val{:x}(),
) where {
  F <: Real,
  S <: Signed,
  var,
} =
  Polynomials.SparsePolynomial{F, var}(Dict{S, F}(zip(monomials, coefficients)))

end
